-- store global reference to the Engine for use in calling functions
Engine = require "engine"
local reader = require 'reader'

function loadobj(obj)
	local faces = {}
	local verts = {}
	
	for i,v in pairs(obj.v) do
			table.insert(verts, {v.x,v.y,v.z})
	end
	for i,v in pairs(obj.f) do
			table.insert(faces, {verts[v[1].v][1], verts[v[1].v][2], verts[v[1].v][3], obj.vt[v[1].vt].u, obj.vt[v[1].vt].v})
			table.insert(faces, {verts[v[2].v][1], verts[v[2].v][2], verts[v[2].v][3], obj.vt[v[2].vt].u, obj.vt[v[2].vt].v})
			table.insert(faces, {verts[v[3].v][1], verts[v[3].v][2], verts[v[3].v][3], obj.vt[v[3].vt].u, obj.vt[v[3].vt].v})
	end
	return faces
end

function love.load()
	local la = love.audio
		
		love.mouse.setRelativeMode(true)
    --love.mouse.setRelativeMode(true)
    love.window.setTitle("ss3d 1.2 demo")
    love.window.setMode(1024, 1024*9/16, {})
    love.graphics.setBackgroundColor(0.52,0.57,0.69)
    Scene = Engine.newScene(love.graphics.getWidth(), love.graphics.getHeight())
    DefaultTexture = love.graphics.newImage("texture.jpg")
    Timer = 0

    Scene.camera.pos.x = 0
    Scene.camera.pos.z = 5
		Scene.camera.pos.y = 2
	
	--LOADING OBJ FILES
	local floorobj = loadobj(reader.load("floor.obj"))
    floorModel = Engine.newModel(ScaleVerts(floorobj, 30, 0.1, 30), DefaultTexture)
    Scene:addModel(floorModel)
		
		st = 0
		p = 0
end

function love.update(dt)
if love.keyboard.isDown("escape") then
	love.mouse.setRelativeMode(false)
end
p = p + dt
		st = st + dt
		if st > 0.5 then
		st = 0
		end
    local mx,my = 0,0
    if love.keyboard.isDown("w") then
        my = my - 1
    end
    if love.keyboard.isDown("a") then
        mx = mx - 1
    end
    if love.keyboard.isDown("s") then
        my = my + 1
    end
    if love.keyboard.isDown("d") then
        mx = mx + 1
    end

    if mx ~= 0 or my ~= 0 then
        local angle = math.atan2(my,mx)
        local speed = 0.1
        Scene.camera.pos.x = Scene.camera.pos.x + math.cos(Scene.camera.angle.x + angle)*speed
        Scene.camera.pos.z = Scene.camera.pos.z + math.sin(Scene.camera.angle.x + angle)*speed
    end
end

function love.mousemoved(x,y, dx,dy)
    -- basic first person mouselook, built into Scene object
    if not Paused then
        Scene:mouseLook(x,y, dx,dy)
    end
end

function love.keypressed(k)
    if k == "space" then
        Paused = not Paused
    end
end

function love.draw()
    -- render all Models in the Scene
    love.graphics.setColor(1,1,1)
    Scene:render()

    -- render a HUD
    Scene:renderFunction(
        function ()
            love.graphics.setColor(0,0,0)
            love.graphics.print("groverburger's super simple 3d engine v1.2")
            love.graphics.print("FPS: "..love.timer.getFPS(),0,16)
        end
    )
end
